﻿using System;
// espace de nom des librairies nécessaire aux sockets TCP/IP
using System.Net.Sockets;


namespace TCPClient
{
    class Program
    {
        static void Main(string[] args)
        {

            // Créé un TcpClient.
            // Ce client ne marchera que si vous avez un serveur TCP/IP en attente de connection sur server:port
            // dans notre exemple le serveur est sur localhost et son port est le 13000

            TcpClient client = new TcpClient("localhost", 13000);

            // associé un flux de client pour la lecture et l'écriture.

            NetworkStream stream = client.GetStream();

            // prépare la data à envoyer 

            Byte[] data = new Byte[256];
            data[0] = 20;


            // Envoie le message au serveur TCP connecté.
            stream.Write(data, 0, data.Length);

            Console.WriteLine("Sent: {0}", data[0]);

            

            // Prépare le Buffer pour stocker les octets de réponse.
            Byte[] buf = new Byte[256];

            // Reçoit la réponse TcpServer.response.
            Int32 bytes = stream.Read(buf, 0, data.Length);

            Console.WriteLine("Received: {0}", buf[0]);

            // Ferme le flux et le socket TCPClient
            stream.Close();
            client.Close();

            Console.WriteLine("\nHit enter to continue...");
            Console.Read();
        }

    }
}