﻿
// ajouter les namespaces utiles pour simplifier l'écriture du code qui suit
using System;
using System.Net.Sockets;
using System.Net;

namespace TCPServer
{
    class Program
    {
        static void Main(string[] args)
        {

            // Buffer d'octets lire les données 
            Byte[] bytes = new Byte[256];

            // déclare la variable port avec sa valeur prédéfinie 13000 (à fournir aux futures clients)
            Int32 port = 13000;
            // met au format IPAddress (sur 32bits) dans la variable localAddr l'adresse IP du serveur, en notation pointée dans la chaine de caractères : "127.0.0.1"
            IPAddress localAddr = IPAddress.Parse("127.0.0.1");

            TcpListener server = new TcpListener(localAddr, port);

            // Lancement du serveur qui se met en attente des demandes de connexions sur le port 13000
            server.Start();

            // Entrée dans la boucle d'attente et d'établissement des connexions
            while (true)
            {
                Console.Write("Waiting for a connection... ");

                // Le programme reste bloqué sur server.AcceptTcpClient() tant qu'il 
                // n'y a pas de demande de connexion
                // dès l'occurence d'une demande server.AcceptTcpClient() retourne un objet
                // newclient pour établir une communication entre le serveur et le client 
                // sur un nouveau port choisi automatiquement par la machine

                TcpClient newclient = server.AcceptTcpClient();
                Console.WriteLine("Connected!");

                // après la connexion, on récupère le canal (flux) de communication côté serveur 
                // pour la lecture et l'écriture vers le client

                NetworkStream stream = newclient.GetStream();

                bytes[0] = 0;
                int i;

                // Loop to receive all the data sent by the client.
                while ((i = stream.Read(bytes, 0, bytes.Length)) != 0)
                {
                    Console.WriteLine("Received: {0}", bytes[0]);

                    // convertit et incrémente le compteur avec une valeur aléatoire comprise entre -2 et 2 
                    int a = (int)bytes[0];
                    Random incr = new Random();
                    a = a + incr.Next(-2,2);
                    bytes[0] = (byte)a;

                    // écrit la nouvelle valeur du compteur vers le client 
                    stream.Write(bytes, 0, bytes.Length);
                    Console.WriteLine("Sent: {0}", bytes[0]);
                }

                // ferme le flux côté serveur 
                // ferme la connexion côté serveur avec le client
                stream.Close();
                newclient.Close();

                Console.WriteLine("\nHit enter to continue...");
                Console.Read();
            }
        }
    }
}